ompi/mca/ptl/gm/ptl_gm.h File Reference.TH "ompi/mca/ptl/gm/ptl_gm.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/gm/ptl_gm.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'mca/ptl/ptl.h'\fP
.br
\fC#include 'ptl_gm_priv.h'\fP
.br
\fC#include 'ptl_gm_peer.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PTL_GM_STATISTICS\fP   0"
.br
.ti -1c
.RI "#define \fBMAX_RECV_TOKENS\fP   256"
.br
.ti -1c
.RI "#define \fBPTL_GM_ADMIN_SEND_TOKENS\fP   0"
.br
.ti -1c
.RI "#define \fBPTL_GM_ADMIN_RECV_TOKENS\fP   0"
.br
.ti -1c
.RI "#define \fBGM_SIZE\fP   30"
.br
.ti -1c
.RI "#define \fBNUM_RECV_FRAGS\fP   256"
.br
.ti -1c
.RI "#define \fBMCA_PTL_GM_FRAG_CACHED\fP"
.br
.ti -1c
.RI "#define \fBOMPI_GM_FREE_LIST_RETURN\fP   OMPI_FREE_LIST_RETURN"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_ptl_gm_component_t\fP \fBmca_ptl_gm_component_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_ptl_gm_module_t\fP \fBmca_ptl_gm_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_ptl_gm_component_open\fP (void)"
.br
.RI "\fIRegister GM module parameters with the MCA framework. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_component_close\fP (void)"
.br
.RI "\fIAny final cleanup before being unloaded. \fP"
.ti -1c
.RI "\fBmca_ptl_base_module_t\fP ** \fBmca_ptl_gm_component_init\fP (int *num_ptl_modules, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fIGM module initialization. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_component_control\fP (int param, void *value, size_t size)"
.br
.RI "\fIGM module control. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_component_progress\fP (mca_ptl_tstamp_t tstamp)"
.br
.RI "\fIGM module progress. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_put\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *sendreq, size_t offset, size_t size, int flags)"
.br
.RI "\fIGM put. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_get\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_peer, struct \fBmca_ptl_base_recv_request_t\fP *sendreq, size_t offset, size_t size, int flags)"
.br
.RI "\fIGM get. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_add_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers, struct ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_del_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_request_init\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *req)"
.br
.RI "\fIPML->PTL Allocate a send request from the PTL modules free list. \fP"
.ti -1c
.RI "void \fBmca_ptl_gm_request_fini\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *req)"
.br
.ti -1c
.RI "void \fBmca_ptl_gm_matched\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *frag)"
.br
.RI "\fIPML->PTL Notification that a receive fragment has been matched. \fP"
.ti -1c
.RI "int \fBmca_ptl_gm_finalize\fP (struct \fBmca_ptl_base_module_t\fP *ptl)"
.br
.ti -1c
.RI "char * \fBmca_ptl_gm_get_local_buffer\fP (void)"
.br
.RI "\fIInternally allocate memory for the unexpected messages. \fP"
.ti -1c
.RI "void \fBmca_ptl_gm_release_local_buffer\fP (char *ptr)"
.br
.ti -1c
.RI "void \fBmca_ptl_gm_dump_header\fP (char *str, union \fBmca_ptl_base_header_t\fP *hdr)"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "\fBmca_ptl_gm_component_t\fP \fBmca_ptl_gm_component\fP"
.br
.ti -1c
.RI "\fBmca_ptl_gm_module_t\fP \fBmca_ptl_gm_module\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Function Documentation"
.PP 
.SS "int mca_ptl_gm_add_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers, struct ompi_bitmap_t * reachable)"
.PP
PML->PTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIpeers\fP (OUT) Set of (optional) peer addressing info. 
.br
\fIpeers\fP (IN/OUT) Set of processes that are reachable via this PTL. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "\fBmca_ptl_base_module_t\fP** mca_ptl_gm_component_init (int * num_ptl_modules, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
GM module initialization. 
.PP
\fBParameters:\fP
.RS 4
\fInum_ptls\fP (OUT) Number of PTLs returned in PTL array. 
.br
\fIallow_multi_user_threads\fP (OUT) Flag indicating wether PTL supports user threads (TRUE) 
.br
\fIhave_hidden_threads\fP (OUT) Flag indicating wether PTL uses threads (TRUE) 
.RE
.PP

.SS "int mca_ptl_gm_del_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers)"
.PP
PML->PTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fInproc\fP (IN) Number of processes. 
.br
\fIprocs\fP (IN) Set of processes. 
.br
\fIpeers\fP (IN) Set of peer data structures. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "char* mca_ptl_gm_get_local_buffer (void)"
.PP
Internally allocate memory for the unexpected messages. 
.PP
We will manage a list of such buffers in order to avoid too many memory allocations. 
.SS "void mca_ptl_gm_matched (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_recv_frag_t\fP * frag)"
.PP
PML->PTL Notification that a receive fragment has been matched. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP (IN) Receive fragment 
.RE
.PP

.SS "int mca_ptl_gm_request_init (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_send_request_t\fP * req)"
.PP
PML->PTL Allocate a send request from the PTL modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (OUT) Pointer to allocated request. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if allocation was successful. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
